/*
Copyright 2021 The OpenEBS Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/openebs/lvm-localpv/pkg/apis/openebs.io/lvm/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeLVMSnapshots implements LVMSnapshotInterface
type FakeLVMSnapshots struct {
	Fake *FakeLocalV1alpha1
	ns   string
}

var lvmsnapshotsResource = schema.GroupVersionResource{Group: "local.openebs.io", Version: "v1alpha1", Resource: "lvmsnapshots"}

var lvmsnapshotsKind = schema.GroupVersionKind{Group: "local.openebs.io", Version: "v1alpha1", Kind: "LVMSnapshot"}

// Get takes name of the lVMSnapshot, and returns the corresponding lVMSnapshot object, and an error if there is any.
func (c *FakeLVMSnapshots) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.LVMSnapshot, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(lvmsnapshotsResource, c.ns, name), &v1alpha1.LVMSnapshot{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LVMSnapshot), err
}

// List takes label and field selectors, and returns the list of LVMSnapshots that match those selectors.
func (c *FakeLVMSnapshots) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.LVMSnapshotList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(lvmsnapshotsResource, lvmsnapshotsKind, c.ns, opts), &v1alpha1.LVMSnapshotList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.LVMSnapshotList{ListMeta: obj.(*v1alpha1.LVMSnapshotList).ListMeta}
	for _, item := range obj.(*v1alpha1.LVMSnapshotList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested lVMSnapshots.
func (c *FakeLVMSnapshots) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(lvmsnapshotsResource, c.ns, opts))

}

// Create takes the representation of a lVMSnapshot and creates it.  Returns the server's representation of the lVMSnapshot, and an error, if there is any.
func (c *FakeLVMSnapshots) Create(ctx context.Context, lVMSnapshot *v1alpha1.LVMSnapshot, opts v1.CreateOptions) (result *v1alpha1.LVMSnapshot, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(lvmsnapshotsResource, c.ns, lVMSnapshot), &v1alpha1.LVMSnapshot{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LVMSnapshot), err
}

// Update takes the representation of a lVMSnapshot and updates it. Returns the server's representation of the lVMSnapshot, and an error, if there is any.
func (c *FakeLVMSnapshots) Update(ctx context.Context, lVMSnapshot *v1alpha1.LVMSnapshot, opts v1.UpdateOptions) (result *v1alpha1.LVMSnapshot, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(lvmsnapshotsResource, c.ns, lVMSnapshot), &v1alpha1.LVMSnapshot{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LVMSnapshot), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeLVMSnapshots) UpdateStatus(ctx context.Context, lVMSnapshot *v1alpha1.LVMSnapshot, opts v1.UpdateOptions) (*v1alpha1.LVMSnapshot, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(lvmsnapshotsResource, "status", c.ns, lVMSnapshot), &v1alpha1.LVMSnapshot{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LVMSnapshot), err
}

// Delete takes name of the lVMSnapshot and deletes it. Returns an error if one occurs.
func (c *FakeLVMSnapshots) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(lvmsnapshotsResource, c.ns, name), &v1alpha1.LVMSnapshot{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeLVMSnapshots) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(lvmsnapshotsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.LVMSnapshotList{})
	return err
}

// Patch applies the patch and returns the patched lVMSnapshot.
func (c *FakeLVMSnapshots) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.LVMSnapshot, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(lvmsnapshotsResource, c.ns, name, pt, data, subresources...), &v1alpha1.LVMSnapshot{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LVMSnapshot), err
}
